// Lecture 3, Example 1 - Dragana Laketic

#include "std_lib_facilities.h"

// Example of function overloading

// In order to use a function, we need to know its name, data type of its return value
// and the list of parameters it takes. (These are the elements of a function
// declaration - remember?)
// If two functions have the same name but differ in any of the two other components
// of the declaration, we have so-called function overloading.
// Below are the two functions defined which have the same name 'add' but differ
// in the type of the return value and the type of the parameters they take.
// We also see an example of how we can provide a default value for one (it applies
// to more than one as well!) of the two parameters: by assigning the value meant to be
// default in the list of parameters. Then, if the function is called without a value
// provided for the parameter declared as default in the parameter list of the function,
// it will be assigned the default value.
int add(int x, int y = 10) {
    cout << "I am adding integers!" << endl;
    
    return x + y;
}
// The function 'double add(double x, double y = 100.0)' overloads the function
// 'int add(int x, int y = 10)' and vice versa.
double add(double x, double y = 100.0) {
    cout << "I am adding real numbers!" << endl;
    
    return x + y;
}

int main() {

    int a{1};
    int b{2};

    // Example of calling a function with a default parameter
    // and which also overloads another function with the same name but
    // different data type of its parameters and return value.
    cout << add(a, b) << endl; // In this case 'int add(int x, int y = 10)' is called
			       // because a and b are variables of type int.
			       // Since we provide the value for the second parameter
			       // in the list, the default value of 10 is ignored.
    cout << add(a) << endl; // In this case 'int add(int x, int y = 10)' is also called
			    // but since we haven't provided the value for the second parameter,
			    // it will be assigned its default value and the function
			    // returns a+10.

    double c{5.7};
    cout << add(c) << endl; // In this case 'double add(double x, double y = 100.0)' is
			    // called because c variable is of type double. The second
			    // parameter is not provided but since it has a default value
			    // the function will return c+100.0
 
    return 0;
}
