// Lecture 3, Example 3 - Dragana Laketic

#include "std_lib_facilities.h"
#include "AnimationWindow.h"

// Example of graphics: drawing simple shapes, text, images in a window

// Mark that additional '#include "AnimationWindow.h"' line!
// Throughout the course we shall use the library AnimationWindow
// to draw (and in a bit also animate) the objects. This library
// was developed especially for the course and is made available
// for use when you create a project through TDT4102 extension in
// VSCode. All you need to do to use it within you code is to remember
// to write the above mentioned include statement!
// We encourage you to read more about the AnimationWindow
// library at https://tdt4102.pages.stud.idi.ntnu.no/documentation/ 
int main() {
    AnimationWindow win; // Variable win is of type AnimationWindow
			 // which is defined in the AnimationWindow library.
			 // Since we haven't provided any additional pparameters,
			 // the window will open with the default parameters.
			 // You can change that - check the documentation. 

    win.draw_circle({300, 400}, 50); // We draw a circle with the center positioned at
				     // 300 pixels horizontally from the top left corner towards right
				     // and 400 pixels vertically from the top left corner downwards.
				     // The radius of the circle is 50 pixels.
				     // The origin {0, 0} for drawing graphic elements is
				     // by convention at the top left corner of the window.
				     // Following are examples for drawing various shapes in
				     // the AnimationWindow. Check the documentation to see
				     // what each parameter means. Change the values and rerun 
    win.draw_rectangle({300, 100}, 100, 50);
    win.draw_quad({450, 350}, {550, 300}, {550, 200}, {400, 250});
    //win.draw_triangle({150, 650}, {250, 500}, {200, 400}, Color::blue_violet);
    win.draw_line({450, 700}, {550, 700}, Color::crimson); // We can change the attributes of the objects.
    // The image used in the example comes from:
    // https://icons8.com/icon/40669/c%2B%2B
    Image img{"icons48.png"};
    win.draw_image({650, 100}, img, 150, 150);
    win.draw_arc({700, 400}, 50, 100, 30, 200, Color::coral);
    win.draw_text({300, 500}, "KJL5", Color::dark_magenta, 80);

    win.wait_for_close(); // Remember to call this function to prevent the window
			  // from closing. In this way, the window will be open
			  // until we close it by pressing the its Close button.
			  // What happens if you remove this function?
    
    return 0;
}
