// Lecture 4, Example 1 - Dragana Laketic

// Demonstration of how to make an animation
// 
// 1) Create an empty frame
// 2) Make a drawing in the frame
// 3) Repeat 1) - 2) as long as the window is open
//
// Note that in order to achieve the impression of movement,
// the position of the drawing must change from one frame to another. 

#include "std_lib_facilities.h"
// For drawing the object(s) in each window frame, we use functions
// from the AnimationWindow library: 
#include "AnimationWindow.h"

int main() {
    // In order to refresh what we learned in the last lecture, let us first
    // draw a static object. For example, a red circle somewhere close
    // to the left edge of the window:
    // (Uncomment the following block /* BEGIN - END */ to run the intro example)
    /* INTRO EXAMPLE - BEGIN
    AnimationWindow win;
    int x{0};   // Change the initial value of x to 50 or more and re-run the example.
                // What value should x have if we want a circle to touch the let edge
                // only at one point?

    // Refresh on the parameters of the draw_ function:
    win.draw_circle({x, 100}, 50, Color::crimson);

    // Remember to keep the window open until explicitly closed
    // by clicking on the window's Close button
    win.wait_for_close();

    return 0;
    INTRO EXAMPLE - END */

    AnimationWindow win; // The first frame is created with the window (step 1) ) 
    int x{0};

    // With the following loop we achieve repetition of steps 1) and 2)
    // Note that we use function should_close() for testing if the window should close!
    while(!win.should_close()) {
        // Step 2) of making animation - drawing 
        win.draw_circle({x, 100}, 50, Color::crimson);

        // Remember to change the position of the drawing so that the drawing
        // in the next frame creates the illusion of movement
        x++;    // Here we increment by 1 [pixel] the x-coordinate of the circle center.
                // We create horizontal movement
        //x += 10; // We can change the speed of the movement by changing the value
                    // of the increment: here we increment by 10 [pixels]

        // We don't want the circle to disappear from the window
        // so we set the limit to how far to the right it can move:
        if (x > 900) {
            x = 0;
        }

        // Step 1) of making animation
        win.next_frame();
    }

    return 0;
}
