// Lecture 5, Example 3 - Dragana Laketic

#include <iostream>

// The definition of a namespace begins with a keyword 'namespace' followed
// by the name of the namespace. In the two definitions below we have defined
// namespaces norsk and nynorsk. Everything defined within these namespace needs
// to be prefixed with name_of_the_namespace:: to be accessed from outside
// the namespace.
// Note that we write std::cout instead of just cout. std:: refers to a namespace
// of the C++ standard library. This library was included in the file std_lib_facilities.h
// which was a part of the main file generated by VSCode's TDT4102 extension. If we
// don't include that file, we need to include the file which contains need definitions
// (look at the line above this comment) and refer to the names from the C++ standard library
// with std:: as in the sayHello() functions below.

namespace norsk {
	void sayHello() {
		std::cout << "God morgen!" << std::endl;
	}
}

namespace nynorsk {
	void sayHello() {
		std::cout << "God morgon!" << std::endl;
	}
}

void sayHello() {
	std::cout << "Good morning!" << std::endl;
}

int main() {
	sayHello(); // This is the call to the English version of sayHello()
	norsk::sayHello(); // This is the call to the Bokmål version of sayHello().
			   // Mark that the call to this function is prefixed with norsk::
			   // because we call a function defined within namespace with the name norsk.
	nynorsk::sayHello(); // This is the call to the Nynorsk version of sayHello() and it is
			     // prefixed with nynorsk::

	return 0;
}
