// Lecture 6, Example 2 - Dragana Laketic

#include "std_lib_facilities.h"

// Example of the data structure struct:
// the syntax begins with the keyword struct followed by its name
// and the block of variables and their respective data types which
// are placed between curly braces and ended with semicolon.
// Usually they would be placed within the header file and then included
// in source code where needed to be used.
// Note that it is a convenience to begin the name of the struct with
// the capital letter.   
struct Navn {
    string first;
    string second;
    int year;
};

// Variables of type struct cannot be printed directly by passing them
// to the operator "<<". We need to define how it will be printed.
// Here is one example where we pass a variable of type Navn (mark that we
// use only the name without the keyword struct) to the function as a parameter.
void printNavn(Navn n) {
    // We get access to individual data members of the variable of type struct by
    // using the dot "." followed by the name of the struct member.
    cout << n.first << " " << n.second << endl;
}

int main() {
    Navn noen{"Jon", "Olav"}; // Definition of variable noen which is of the type
			      // Navn (the struct with the name Navn as declared
			      // in the beginning of this file). Variable noen is
			      // initialised to noen.first = "Jon" and noen.second = "Olav".
    Navn enannen; // variable enannen is also of the type Navn but is not initialised.

    cout << "First man on the Moon: " << endl;
    printNavn(noen); // Example of passing a variable of the struct type Navn to the function
    cout << "En annen ville bli til: " << endl;
    printNavn(enannen);
    enannen = noen; // We can assign the values of one struct variable to another
		    // just like with do with variables of any other type.
    cout << "Sier en gang til: en annen ville bli til " << endl;
    printNavn(enannen);
    return 0;
}
