// Lecture 6, Example 3 - Dragana Laketic

#include "std_lib_facilities.h"

// Example of a function which takes in a const reference and
// in that way guarantees that the value of the variable the
// reference rr refers to will not be changed within the function. 
void CheckNotChange(const int& rr) {
    cout << "Just checking " << endl;
    cout << rr << endl;
    // Uncomment the line below and call this function.
    // cout << "The following year " << r++ << endl;
    // It is not be possible to change the value of rr
    // because it is declared as reference to const int value.
}

// Example of a function which returns more than one value.
// The function takes in several references. Within the function
// the values of the variables to which these references refer are
// changed by being accessed through references. This will lead to
// the values of variable in the main function to be changed after
// the program returns from the function.
void TiGangerR(int& a, int& b, int& c) {
    a *= 10;
    b *= 10;
    c *= 10;
}

// Example of a function which does not change the values of the
// variables which are passed to it as parameters.
// Compare it with the function TiGangerR().  
void TiGangerV(int a, int b, int c) {
    a *= 10;
    b *= 10;
    c *= 10;
}

int main() {
    int first{1900};
    int& rf = first; // Example of definition of the variable which
		     // is reference to variable of the type int.
		     // We use '&' right after the name of the data type
		     // (in this case int) of the variable to which
		     // the reference refers to. Reference rf is set to
		     // refer to variable first.

    int en{1};
    int to{2};
    int tre{3};
    int& ren{en}; // Reference ren refers to variable en.
		  // It is of type int& (reference to variable of type int)
		  // because en is a variable of type int.
    int& rto{to};
    int& rtre{tre};

    const int& crf{first}; // Keyword 'const' in the definition of the reference crf
			   // guarantees that the value of the variable it refers to
			   // will not be changed

    cout << "We start talking Quantum in " << rf << endl; // When accessed, the reference variable shows
							  // the value of the variable it refers to.
    rf = 1926; // By assigning a different value to the reference we actually change the value
	       // of the variable the reference refers to ...
    cout << "Photon gets its name in " << first << endl; // ... as shown when we print out the variable.

    cout << "Norsk på " << ren << " " << rto << " " << rtre << endl;
    TiGangerR(ren, rto, rtre); // Example of returning more than one value from a function.
			       // Mark that we send references to variables as function parameters
			       // and have these references changed in the function. When we return
			       // form the function, the values of the variables are changed
			       // as the following output shows:
    cout << "Norsk på " << en << " " << to << " " << tre << endl;
    TiGangerV(en, to, tre); // When we send the variabls as parameters, their values will not be changed
			    // when we return from the function.
    cout << "Norsk på " << en << " " << to << " " << tre << endl;

    //the line below will generate an error
    //cout << crf++ << endl; // We cannot change the value of a variable is the reference
			   // which refers to it is declared as 'const'.
    CheckNotChange(crf); // Example of a function which guarantees not to change the value
			 // of the variable to which the reference refers.

    return 0;
}
