#include "std_lib_facilities.h"
#include "Counter.h"
#include "AnimationWindow.h"

const double pi = 3.1415927;

void printTrafficLightState(int state) {
    if(state == 0 || state == 1)
}

enum class TrafficLight {
    RED, RED_ORANGE, ORANGE, GREEN
};

const TrafficLight state = TrafficLight::RED;

// Last time:
// - Build systems
// - Struct
// - Const
// - References

enum class TemperatureUnit {
    CELCIUS = 0, 
    FAHRENHEIT = 1, 
    KELVIN = 2
};

string unitToString(TemperatureUnit unit) {
    if(unit == TemperatureUnit::CELCIUS) {
        return "Celcius";
    } else if(unit == TemperatureUnit::FAHRENHEIT) {
        return "Fahrenheit";
    } else if(unit == TemperatureUnit::KELVIN) {
        return "Kelvin";
    }

    switch(unit) {
        case TemperatureUnit::CELCIUS:
            return "Celcius";
        case TemperatureUnit::FAHRENHEIT:
            return "Fahrenheit";
        case TemperatureUnit::KELVIN:
            return "Kelvin";
    }
    return "Unknown Unit";
}



enum class AnotherTemperatureUnit {
    CELCIUS = 0, 
    FAHRENHEIT = 1, 
    KELVIN = 2
};

enum CarColour {
    GREEN, BLUE
};

enum HouseColour {
    RED, ORANGE, WHITE
};

int tempUnitToInt(TemperatureUnit unit) {
    return static_cast<int>(unit);
}

TemperatureUnit intToTempUnit(int value) {
    return static_cast<TemperatureUnit>(value);
}

struct TemperatureMeasurement {
    double value = 0;
    TemperatureUnit unit = TemperatureUnit::CELCIUS;

    string toString() {
        return to_string(value) + " " + unitToString(unit);
    }
};

TemperatureMeasurement doMeasurement() {
    TemperatureMeasurement measure;
    return measure;
}

// Library:
// - Header files
// - Kildefilder (.cpp)
// - Library files 

// Build system: CMake, Meson

double sum(const vector<double>& vec) {
    double total = 0;
    for(int i = 0; i < vec.size(); i++) {
        total += vec.at(i) + 2 * pi;
    }
    return total;
}

void setToZero(double& a, double& b) {
    a = 0;
    b = 0;
}

int main() {
    TemperatureUnit unit = TemperatureUnit::CELCIUS;
    cout << unitToString(unit) << endl;

    Counter counter(10);
    counter.countOne();

    Counter anotherCounter = counter;

    cout << counter.toString() << endl;

    cout << "Hello, World!" << endl;
    const double pi = 3.1415927;
    const bool writeErrorMessages = false;

    //const array<int, 5> constArray;
    //constArray.at(4) = 3;

    if(writeErrorMessages) {
        std::cout << "Oh no something went wrong!" << std::endl;
    }

    vector<double> values = {1, 2, 3, 4, 5};
    sum(values);

    return 0;
}