#include "Mission.h"

// This file contains definitions of member functions
// of the class Mission. Note that it includes a corresponding header
// - a file of the same name but with the extension .h, where
// the class is declared.

// Class declaration in corresponding header file, which is also
// a definition as in Mission.h, introduces a namespace with the
// same name as the name of the class. Therefore, when writing a
// definition of the class members outside of the class declaration
// (and definition!), we need to specify namespace by <class_name>::
// which is 'Mission::' for the 'class Mission'.

// Definition of constructor 'Mission()' which takes no parameters.
Mission::Mission() {
    // Hereby we define that when this constructor is called, an
    // object of type 'Mission' will be created and its data members
    // assigned the following values:
    name = "Voyager 1";
    year = 1977;
    yearssincelaunch = 2024 - year;
}

// It is possible to initialise data members as in the following example.
// It is a re-definition of a constructor which takes no parameters, just like
// the one above, so only one of the two should be kept uncommented at the time.
// In this case we peovide initial values for the data members after the colon, ':',
// which follows the function name and list of parameters. Each data member initialisation
// is done by the known notation of providing an initial value within the braces after the
// data member name. In this way we truly initialise data memebrs at the time of
// the object construction in the memory. For the case of the constructor definition
// above, we initialise the values in the constructor body, i.e., the space in the
// memory is first allocated and then the values set within the constructor function.
// (You usually do not note the difference but this should be preferred way for true initialisation)
/*
Mission::Mission() : name{"Voyager 1"}, year{1977} { // the list of data and their initial values
						     // which follows after colon ':' is called 'initialisation list'
    // And here we assign an initial value to the data member 'yearssincelaunch'
    // based on the value of data member 'year'
    yearssincelaunch = 2024 - year;
}
 */

// Definition of constructor Mission(string nn, int yr) which takes
// two parameters and initialises the class' data members with the values
// of the parameters. Note that we use the initialisation list to
// initialise 'name' and 'year' at the time of their construction in the memory.
Mission::Mission(string nn, int yr) : name{nn}, year{yr} {
     yearssincelaunch = 2024 - year;
}

// Definition of member function. Note that this function has an access to
// the data members although they are 'private'. This is because it is a _member_function_.
// We don't need to use namespace <class_name>:: in front of the names of data members
// when we use them in this function - we are in the same namespace!
void Mission::printMission() {
    cout << "Mission " << name << " launched in " << year <<
        " orbiting for " << yearssincelaunch << endl;
}
