#include "std_lib_facilities.h"

// Example of declaration of 'enum class',
// a special type which enables us of using a type
// which contains certain number of descrete values.
// As a rule, we keep such declarations within header files
// and then include these headers when we want to use the
// them in our source files but here we keep it in the same
// file with the main-function for the sake of keeping it
// easy to follow the example.
// Declaration (end definition in this case) begins with
// keywords 'enum class' followed by the name of the enumeration,
// 'LakeColours' in this case.
// Each value of enum class has an integer value associated with it
// and if not specified, it defaults to 0. Each next provided value
// in 'enum class' has the value which equals to previous memebr+1.
// In the example below, the first value is set to have value 5 which
// means that lakeColours::BLACK has value 6 and LakeColours::GREY
// has value 7. Note that again we need to use a namespace qualifier
// to get access to the enum class value, just like with classes.
enum class LakeColours {
    BLUE = 5, BLACK, GREY
};

// In this example the first element of the enum class has value 0,
// by default.
enum class PlanetColours {
    BLUE, RED, WHITE
};

int main() {
    LakeColours cll = LakeColours::BLACK; // Example of the variable of the type 'enum class'.
					  // It is initialised to value LakeColours::BLACK.
    PlanetColours cpl = static_cast<PlanetColours>(2); // Yet another example of a variable of type 'enum class'.
						       // It is initialised to the value in PlanetColours:: which
						       // has value 2. Check in the debugger which value it is that
						       // this vaiable is assigned to.
						       // Note that we use static_cast<>() to convert the integer
						       // value to the corresponding 'enum class' member.

    cout << "cll er verdi " << static_cast<int>(cll) << endl; // Here we print to the terminal the integer
							      // which corresponds to 'enum class' value
							      // assigned to variable cll.

    return 0;
}
