// Lecture 8, Example 1 - Dragana Laketic

#include "std_lib_facilities.h"

// We use filesystem from C++ standard library to work with files.
int main() {
        // Declaration of variable of type path (note that it can be used
        // for directories as well as for the files - they can both
        // be seen as paths within a filesystem on your computer)
        // can be done in different ways:
    std::filesystem::path stien{"solar"};
    std::filesystem::path stienTilMinFil{"solar/planets.txt"};
    std::filesystem::path filenPaaStien = stien / "planets.txt";
        // We can use function absolute() to retrieve and absolute path
        // of a directory or file:
    std::filesystem::path absolutStien = std::filesystem::absolute(stien);
        // We can find out what the working directory is by calling
        // function current_path():
    std::filesystem::path workingDirectory = std::filesystem::current_path();

    cout << stien << endl;
    cout << stienTilMinFil << endl;
    cout << filenPaaStien << endl;

    cout << absolutStien << endl;

    cout << workingDirectory << endl;

        // Check if two paths are equivalent:
    bool areEqual = std::filesystem::equivalent(stien, absolutStien);
    cout << areEqual << endl;

        // Check if the path exists
        // (list your current directory and see if
        // the inquired directory or file is there; create it if not then
        // run the code again)
    if (std::filesystem::exists(stien)) {
        cout << "Path " << stien << " exists." << endl;
    } else {
        cout << "Path " << stien << " does not exist." << endl;
    }
    std::filesystem::path stienTilMaanen{"lunar"};
    if (std::filesystem::exists(stienTilMaanen)) {
        cout << "Path " << stienTilMaanen << " exists." << endl;
    } else {
        cout << "Path " << stienTilMaanen << " does not exist." << endl;
    }

        // We can use string() function on path variable to return it as string:
    cout << workingDirectory << endl;
    cout << workingDirectory.string() << endl;

    // We can copy files
    // (make mars.txt from terminal and add something to it,
    // then run the code)
    std::filesystem::path mars{"mars.txt"};
    std::filesystem::path venus{"venus.txt"};

    std::filesystem::copy(mars, venus);
    // Check that venus.txt is created and has the same content as mars.txt

    // We can create directory by calling create_directories():
    std::filesystem::path nyMaane{"martian/phobian"};
    std::filesystem::create_directories(nyMaane);

    // We can delete a file or directory:
    std::filesystem::path toDelete{"martian"};
    std::filesystem::remove_all(toDelete);

    // ... or rename it:
    std::filesystem::path nyNavn{"mercury.txt"};
    std::filesystem::rename(mars, nyNavn);

    // We can get the size of the file [bytes]
    unsigned int sizeOfMars = std::filesystem::file_size(nyNavn);
    cout << "The size of Mars is " << sizeOfMars << " [bytes]" << endl;

   return 0;
}
