// Lecture 8, Example 2 - Dragana Laketic

//#include "std_lib_facilities.h"
#include <filesystem>
#include <fstream>
#include <iostream>

// We can use the stream model to read from and write to files the same way
// we have used it for reading from and writing to the terminal. This is
// enabled by library fstream.

int main() {
        // Variables of type ofstream can be used the same way as cout.
    std::filesystem::path enFil{"bakklandet.txt"};
    std::ofstream of{enFil}; // Here is an example of the declaration of
                            // an ofstream (output file stream) variable
                            // which is tied to a path variable from filesystem
                            // namespace. The path is (or should be) automatically
                            // open for output stream. (It is wise to check
                            // the status, whether any errors have accurred and the
                            // file/path is in good state for writing to.)
                            // We can also provide a string with the name of the file
                            // we want to write to, but it is a good practice to
                            // use path type from filesystem.

    of << "Rabarbrateateret" << std::endl; // Example of writing to a file using
                                    // stream model adn functionality from fstream header.

        // Analogously, ifstream (input file stream) is used for
        // reading from the file.
    std::ifstream readMe{enFil};
    std::string teater;
    readMe >> teater; // This looks like reading from the terminal (cin) with
                    // ifstream variable representing the file we want to read from.
    std::cout << "Skal til " << teater << " i august." << std::endl;

        // Here we write one more line to the file represented by of:
    of << "Midt paa Bakklandet i byen vaar. " << std::endl;
    std::string enLinje;
    std::string nesteLinje;
        // We can read the whole line from the file via ifstream by using
        // function getline().
    std::getline(readMe, enLinje);
    std::getline(readMe, nesteLinje);
    std::cout << enLinje << std::endl;
    std::cout << nesteLinje << std::endl;

    return 0;
}
