// Lecture 8, Example repetition - Dragana Laketic

#include "std_lib_facilities.h"
#include "planet.h"

// This simple game helps us refresh upon random number generation and
// how to make a loop for the interaction with the user. It also shows
// some good sides of object-oriented programming style - in particular
// the use of struct and the data type Planet we define as a struct so that
// we have control over how a variable of that type is instantiated and used.
int main() {
        // a set of variables we use for random number generation
    random_device device;
    unsigned int rndSeed = device();
    default_random_engine engine(rndSeed);
    uniform_int_distribution distr(0, 100);
        // variables to contain random number and user's guess
    int yourGuess{0};
    int rndCast{0};
        // three variables of type Planet which will be used in the game
    Planet p1; // Planet p1 will be initialised by a default constructor
    Planet p2{"Mars", 2}; // Planet p2 and p3 will be initialised by
                            // the constructor which takes in two parameters:
                            // one of type string and second of type int.
    Planet p3{"Venus", 3};

    cout << "Enter a number to start the game (or -1 to skip it):" << endl;
    cin >> yourGuess;
    while(yourGuess != -1) {
        rndCast = distr(engine) % 3; // By using % 3 operation we ensure
                                    // that random generated numbers will be 0, 1 or 2.
        switch (rndCast) {
            // There is a lot of repetitive code within this switch() statement.
            // This is the case where a function would be a good wya of providing
            // the same functionality. For exercise - write such function and use it here.
            case 0:
                cout << "My name is " << p1.name << ". Guess my number: 1, 2 or 3!" << endl;
                break;
            case 1:
                cout << "My name is " << p2.name << ". Guess my number: 1, 2 or 3!" << endl;
                break;
            case 2:
                cout << "My name is " << p3.name << ". Guess my number: 1, 2 or 3!" << endl;
                break;
            default:
                break;
        }
        cin >> yourGuess;
        if (yourGuess == rndCast+1) {
            cout << "You've guessed it! Well done!" << endl;
        }
        cout << "Another round! To end the game enter -1" << endl;
    }

    // There were only three planets to play with. How would you change the code
    // if you would allow many more to be in the game?
    // For exercise: use a vector of variables of type Planet. Write a function
    // which populates this vector with as many planets as the user specifies and
    // then run the game. This part you may work on after you get the grasp of
    // the new material in this lecture.

    cout << "Since you are leaving, here are the planets that were in the game:" << endl;
    printPlanet(p1);
    printPlanet(p2);
    printPlanet(p3);

    return 0;
}
