// Lecture 8, Example repetition - Dragana Laketic

#pragma once
#include <iostream>

// This file contains declaration of the struct Planet.
// It also contains declaration(s) of so-called utility functions
// related to this struct. They are functions which are helpful when
// using objects of type struct. As a rule, their definitions are placed
// in the .cpp file with the same name as the header - planet.cpp in this case.

struct Planet {
    public: // Members of a struct have public visibility by default.
            // If we list them first, we don't have to write 'public'
            // explicitly as it is done in this example
        std::string name;
        Planet() : name{"Earth"}, myNumber{1} {} // default constructor
                // (refers to the line below this comment)
                // Constructor which uses two parameters to initialise object
                // of type Planet: one string and one int. Mark the default value
                // set to the second parameter. If we just initialise an object
                // with the first parameter passed, the second parameter will have
                // a value of 100 assigned and in that way prevent illegal use of
                // mamber myNumber.
        Planet(std::string nm, int numb = 100) : name{"Earth"}, myNumber{1} {}
        int getMyNumber() {return myNumber;} // public function which allows other
                                            // functions outside struct to get to know
                                            // the value of its private member.
    private:
        int myNumber; // This member of the Planet struct is has private visibility.
                    // It cannot be accessed directly from any other function. But,
                    // we allow it to be read by public function getMyNumber() defined
                    // in the public section of Planet.
};

void printPlanet(const Planet& planeta); // Declaration of one convenient function
                                        // for the use of Planet.
