#include <std_lib_facilities.h>
#include <Color.h>
// Virtuelle funksjoner / virtual functions

// Operatoroverlasning
class Point {
public:
    int x;
    int y;

    // Venstre parameteren er instansen av klassen
    Point operator+(Point other) {
        return {x + other.x, y + other.y};
    }


};

Point operator+(Point a, Point b) {

}

Point operator-(Point b, Point a) {
    Point delta;
    delta.x = b.x - a.x;
    delta.y = b.y - a.y;
    std::cout << "Computed delta!" << std::endl;
    return delta;
}

Point operator*(Point a, int b) {
    return a;
}

Point operator*(int b, Point a) {
    return a * b;
}



void computePoints() {
    Point a;
    a.x = 5;
    a.y = 7;

    Point b;
    b.x = 9;
    b.y = 5;

    Point delta = b - a;

    delta = 5 * delta;


}

class LampSocket {

};


class Lamp { // Parent class / foreldreklasse
    bool isLit = false;
private:
    string manufacturer = "Some lamp manufacturer";
public:
    Lamp(string manufacturer) : manufacturer{manufacturer} {

    }
    void toggleSwitch() {
        isLit = !isLit;
    }
    bool isLightOn() {
        return isLit;
    }
    // Helvirtuell funksjon
    // -> klassen har blitt abstrakt
    virtual void breakLamp() = 0;

    friend std::ostream& operator<<(std::ostream& stream, Lamp& lamp);
    friend LampSocket;
};

std::ostream& operator<<(std::ostream& stream, Lamp& lamp) {
    stream << "A lamp made by: " << lamp.manufacturer << std::endl;
    return stream;
}

// public Lamp:
// public -> public
// protected -> protected
// private -> private

// private Lamp:
// public -> private
// protected -> private
// private -> private

class ColouredLamp : public Lamp { // Child class / barneklasse
    TDT4102::Color lightColour = TDT4102::Color::orange;
public:
    ColouredLamp() : Lamp("manufacturer") {

    }
    TDT4102::Color getColour() {
        return lightColour;
    }
    virtual void breakLamp() override { // Override
        std::cout << "Connection lost!" << std::endl;
    }
};

void dropLamp(Lamp& lamp) {
    lamp.breakLamp();
}

class Character {
    void drop();
};

std::ostream& operator<<(std::ostream& stream, std::vector<double>& vec) {
    stream << "vector<double>(";
    for(int i = 0; i < vec.size(); i++) {
        stream << vec.at(i) << ", ";
    }
    stream << ")";
    return stream;
}


int main() {
    std::vector<double> sequence1 = {1.2, 1.6, 1.9, 2.2, 2.3, 2.4};

    std::cout << sequence1 << std::endl;


    std::vector<double> sequence2 = {7.6, 3.6, 7.4, 3.4, 3.6, 3.5};
    ColouredLamp colouredLamp;
    dropLamp(colouredLamp);
    std::cout << colouredLamp << std::endl;

    computePoints();


    

    //ColouredLamp anotherLamp = static_cast<ColouredLamp>(temp);




    
    std::ofstream outFile{"output.csv"};

    if(!outFile) {
        std::cout << "Something went wrong!" << std::endl;
        return 0;
    }

    outFile << "Column 1, Column 2" << std::endl;

    for(int i = 0; i < sequence1.size(); i++) {
        outFile << sequence1.at(i) << ", " << sequence2.at(i) << std::endl;
    }
    
    return 0;
}
