//Lecture 9, Examples 1, 2, 3 and 4, PhotonicQubit.h file - Dragana Laketic

#pragma once
#include "Qubit.h"

//Definition of class PhotonicQubit.

//After keyword class followed by the class name there is a
//colon with keyword public and name of the class Qubit.
//This is a syntax which tells us that class PhotonicQubit is
//a derived class / child class of base class / parent class Qubit.
//It means that the object of the type of this class inherits members
//of its base class, Qubit, but also has some extra members as defined
//below: three data members of type double and member functions
//myState() and getMyFrequency() which override the functions from
//the base class. It also has two constructors: one default and
//one which takes three arguments.
class PhotonicQubit : public Qubit {
    double rail1;
    double rail2;
    double laserFrequency;
public:
    	//Pay attention to how the initialisation list for the constructors contains
    	//a call to a base class constructor (in this case we call a default constructor
    	//with no arguments).
    PhotonicQubit() : Qubit(), rail1{0.7}, rail2{0.3}, laserFrequency{0.003} {}
    PhotonicQubit(double r1, double r2, double lf) :
        Qubit(), rail1{r1}, rail2{r2}, laserFrequency{lf} {}
    void myState();
    void getMyFrequency();
    //void getMyFrequency() override; // We can also use word override to be explicit that this function
    					//overrides a function from its base class.
    	//class PhotonicQubit declares class Helper to be its friend.
	//This means that members of the Helper class can have access to
	//the members of this class. See file Helper.cpp where member functions
	//of class Helper are defined and how they access dat amembers of this class.
    friend class Helper;
};
