// Lecture 9, Examples 1, 2, 3 and 4, Qubit.h file - Dragana Laketic

#pragma once

//Definition of class Qubit which is used as a superclass/
//parent class / base class in our example.
class Qubit{
	//Members of a class are private by default.
	//If they are listed straight after the open brace,
	//it is not needed to write access-qualifier private.
	//This means that two double variables theta and phi
	//are private for the class Qubit: only member functions
	//(methods) of the Qubit class can access them.
    double theta;
    double phi;
protected:
    	//Members of a class declared after protected access qualifier
	//can be accessed by the class member functions and by
	//the member functions of the derived classes of this class.
	//See definitions of classes PhotonicQubit and
	//SuperconductingQubit and their member functions
	//void myState(): measuredState declared below from this
	//base class is used within definitions of those member
	//functions. It can be done so because int measuredState
	//is declared with the protected access.
    int measuredState;
public:
    	//Definition of default constructor.
	//This constructor takes no arguments and it will be called when
	//a variable of type Qubit is declared without initialisation.
	//The initialisation which follows after the colon initialises
	//data members to certain values.
	//We have chosen this default constructor to be inline, i.e.,
	//its definition is provided within the class definition between
	//braces - an empty funciton body in this case.
	//It is not a good practice to keep mmebr functions inline within
	//the class definitions but for such short functions it goes well.
    Qubit() : theta{0.0}, phi{90.0}, measuredState{-1} {}
    	//Another constructor which takes three arguments. It will be called
	//for an object declared as type Qubit and initialised to three
	//values: two double and one int provided by the user.
    Qubit(double th, double ph, int m) : theta{th}, phi{ph}, measuredState{m} {}
    	//Member function which gives user a possibility to read the value
	//of the member phi. Again, because it is very short, it was chosen
	//to keep it inline.
    double getQuantumPhase() {return phi;}
    	//Declaration of a member function. See the corresponding Qubit.cpp
	//file for its definition.
    void myState();
    	//Declaration of a virtual function. It means that when a derived class
	//overrides its definition, the mechanism of a runtime polymorphism
	//will be activated. This means that a reference to an object of type
	//Qubit which refers to a variable of a type of a derived class will
	//call the version of the function getMyFrequency() which is defined
	//for the derived class object, not this one for the base class although
	//the reference is declared as type Qubit&. The right version of the
	//virtual function is determined during the runtime. Therefore the name
	//runtime polymorphism. See example 2) Virtual functions in main.cpp.
    virtual void getMyFrequency();
    	//If we declare a virtual function like in the line below, it means
	//that the class which contains it is a pure virtual class. That means
	//that we cannot have an instance of this class, i.e., an object of the
	//type of a pure virtual class. Pure virtual function has no definition.
	//If you uncomment the line below and comment out the line above and try
	//to declare a variable of type Qubit in the main(), you will get compiler
	//error. Pure virtual base functions are useful for implementations of
	//runtime polymorphism or just as an abstract base class which makes
	//no sense to be instantiated but still keeps many useful common properties
	//of its derived classes at one place.
    //virtual void getMyFrequency()=0;
};
