// Lecture 9, Examples 1, 2, 3 and 4, main.cpp file - Dragana Laketic

#include "std_lib_facilities.h"
#include "Qubit.h"
#include "PhotonicQubit.h"
#include "SuperconductingQubit.h"
#include "helpers.h"

// Topics of today's lecture
// 1) Inheritance
// 2) Virtual methods
// 3) Operator overloading
// 4) friend keyword (friend functions and friend classes)

// 3) Operator overloading
// NOTE: the two function definitions below (before main() function) are kept in
// the same file for clarity. They hsould be moved to a separate file and their
// declarations included through a corresponding header file.
//
// An example of an overloaded operator + which operates on a variable of type string
// and a variable of type int. The result is a variable of type string.
string operator+(string name, int num) {
    return "I want " + to_string(num) + " pieces of " + name + " pets";
}

// An example of an overloaded operator + which operates on two variables of type class
// SuperconductingQubit and produces the results of the same type (class SuperconductingQubit).
// The result of + operation is an object of type SuperconductingQubit which has a data member
// pulseFrequency equal to the sum of pulseFrequency data members of bjects s1 and s2 (see
// the definition of the function).
SuperconductingQubit operator+(SuperconductingQubit& s1, SuperconductingQubit& s2) {
    SuperconductingQubit qRet;

    qRet.setFrequency(s1.getFrequency()+s2.getFrequency());

    return qRet;
}

int main() {
	// 1) Inheritance
	// Objects of type PhotonicQubit adn SuperconductingQubit inherit
	// data members and member ffunctions from their base (parent, super)
	// class Qubit. See definitions of these classes in their respective
	// files. However, when calling a member function of the same signature
	// their parent's member function, if they have their own version defined,
	// it will override the definition provided by the parent. Pay attention
	// to definitions of function myState() in class Qubit and its children classes
	// PhotonicQubit and SuperconductingQubit and what the program would produce
	// when tehse are called on variables q1, q2 and q3.
    Qubit q1;
    double phase;
    PhotonicQubit q2;
    SuperconductingQubit q3;

    	//Example of calling member functions of class Qubit.
    cout << "Qubit:" << endl;
    phase = q1.getQuantumPhase();
    cout << phase << endl;
    q1.getQuantumPhase();
    q1.myState();

    	//Example of calling a member function which child class
	//inherits from its parent class (getQuantumPhase) and
	//a member function which overrides the one defined by
	//the parent class (myState).
    cout << "Photonic qubit:" << endl;
    q2.getQuantumPhase();
    q2.myState();
	//One more example of calling a member function for an
	//object of the child class which overrides the definition
	//provided by the parent class.
    cout << "Superconducting qubit:" << endl;
    q3.myState();

    	//Example of calling member functions of the same name and
    	//signature for two objects: one of type class PhotonicQubit
    	//and another of type SuperconductingQubit.
    q2.getMyFrequency();
    q3.getMyFrequency();

    // 2) Virtual functions
    // Here is an example of runtime polymorphism. Two references
    // to object of type Qubit will call different functions dependent
    // on which type of the derived class ovject they refer to. Which
    // function will be called is decided upon during the program run -
    // therefore the name runtime polymorphism.

    	//We declare two variables of the type reference to object of type
	//class Qubit. The first reference is set to refer to a variable of
	//the type PhotonicQubit and the second to the variable of the type
	//SuperconductingQubit.
    Qubit& rPQ = q2;
    Qubit& rSQ = q3;

    	// ... the first line below will call getMyFrequency() of the
    	// PhotonicQubit class, and the second line will call getMyFrequency()
    	// of the SuperconductingQubit class.
    rPQ.getMyFrequency();
    rSQ.getMyFrequency();

    // 3) Operator overloading
    // See definitions of the two funcitons before the beginning of the main() function.
    // NOTE: those definitions are kept in this file for clarity, otherwise we
    // would define them in a separate file and include only their declarations
    // in this file.
    string name{"puppy"};
    int howMany{5};
    	//Notice how we use operator + in a usual way:
	//result = operand_1 + operand_2
	//while we call function string operator+(string name, int num)
	//as defined in the beginning of this file.
    string wish = name + howMany;
    cout << wish << endl;

    	//Another example of using overloaded operator +.
	//The definition of the funciton called is given in the beginning
	//of this file.
    SuperconductingQubit sq1{};
    SuperconductingQubit sq2{};
    	//Again, we use operator + in a usual way:
	//result = operand_1 + operand_2
    SuperconductingQubit sum = sq1 + sq2;
	//The output produced by the line below shows that the body of
	//the function
	//SuperconductingQubit operator+(SuperconductingQubit s1, SuperconductingQubit s2)
	//was invoked since the pulseFrequency of the result is equal to the sum
	//of the two operans' pulseFrequency-ies.
    cout << "Frequency of the sum: " << sum.getFrequency() << endl;

    	//An example of calling an overloaded operator ++ which is
	//defined as a member function of the class SuperconductingQubit
	//(see the corresponding class definition in the SuperconductingQubit.h/.cpp).
	//Notice how we call this operator just like any other member function.
    cout << "Before increment: " << sq1.getFrequency() << endl;
    sq1.operator++();
    cout << "After increment: " << sq1.getFrequency() << endl;

    // 4) friend
    	// An example of calling a friend function.
    	// Look into the definition of class SuperconductingQubit which
    	// contains declaration that function peepingTom() is its friend.
    peepingTom(sq1);

    	//An example of calling a friend class.
	//Revisit the definition of class PhotonicQubit and notice
	//how it contains declaration that class Helper is a friend class.
    Helper hlp;
    hlp.dualRails(q2);

    return 0;
}
