// Lecture 11, Repetition example, Dragana Laketic

#include "std_lib_facilities.h"
#include "points.h"

// Classes Point, CartesianPoint and PolarPoint which we used
// in the lecture for the repetition of class inheritance,
// overloading and virtualisation, are defined in the "points.h"
// file which is here renamed to "parallel2_repetition_points.h".

int main() {
    // Repetition
    // Repetition: Inheritance, virtualisation and abstract classes

    // Point point1; // NOTE: this instantiation is not possible after
                    // class Point became an abstract class when we made a pure
                    // virtual function printMyCoordinates() by adding '=0'
                    // at its declaration.
                    // No object - an instance of an abstract class - can be
                    // created in the program.
    CartesianPoint decartes(5.4, 6.7);
    PolarPoint euler(1.2, 4.5);
    Point& refPoint1 = decartes; // A reference to a parent abstract class
    Point& refPoint2 = euler; // Another reference to a parent abstract class

    // Overriding example
    cout << "Overriding base abstract class methods:" << endl;
    // point1.printMyCoordinates(); // NOTE: we cannot call any method of an abstract class!
                                    // We could run this line before we made class Point to be
                                    // an abstract class by adding a pure virtual function
                                    // as its member function!
    decartes.printMyCoordinates(); // Member function printMyCoordinates() of the
                                    // child class CartesianPoint is called. It overrides its
                                    // parent definition of the same function - same name,
                                    // same return type, same parameter list.
    euler.printMyCoordinates(); // Member function printMyCoordinates() of the child
                                // class PolarPoint is called - it overrdies its parent
                                // of the same function.

    // Example of virtualisation mechanism:
    // Both refPoint1 and refPoint2 are of the same type: references to Point,
    // but each calls the method of the child class to which the reference is assigned:
    // refPoint1 calls printMyCoordinates() of the class CartesianPoint and
    // refPoint2 calls printMyCoordinates() of the class PolarPoint
    cout << "Virtualisation: calling exact methods via reference to parent class:" << endl;
    refPoint1.printMyCoordinates();
    refPoint2.printMyCoordinates();

    return 0;
}
