// Lecture 12, Example 3: testing

#include "std_lib_facilities.h"
#include <cassert>

int factorial(int number) {
        // We can use assert command from <cassert> to ensure
        // the input parameter is not a negative value.
        // When you call factorial function with a negative value
        // passed as a parameter, check the message in the terminal:
        // assert statement will point you to the line in the code
        // which failed.
    assert(number >= 0);
    if (number == 0) {
        return 1;
    } else {
        return number*factorial(number-1);
    }
}

int main() {
    cout << "Testing factorial() function" << endl;
    // Test valid input
    cout << "Input: " << 4 << " Output: " << factorial(4) << " (test: 24)" << endl;
    // Test corner case
    cout << "Input: " << 0 << " Output: " << factorial(0) << " (test: 1)" << endl;
    // Test invalid input
    cout << "Input: " << -11 << " Output: " << factorial(-11)
        << " (test: assert statement!)" << endl;
    cout << "Input: " << 'A' << " Output: " << factorial('A')
        << " (test: non-sensical value!)" << endl;
    // Test random input: use random number generator to generate inputs
    // Call function under test for these values and compare the return result
    // with hte result obtained from, for example, another factorial function
    // from some other library. We can use the same seed value for the random
    // number generator if we want a repeatable set of results.
    return 0;
}