
#include "std_lib_facilities.h"

template<typename T>
void print(T a) {
    std::cout << a << std::endl;
}

template<typename T>
struct NotAVector {
    T a;
};

#include <queue>
#include <deque>

struct Vector2 {
    float x;
    float y;

    Vector2 operator+(Vector2& a) {
        Vector2 out;
        out.x = x + a.x;
        out.y = y + a.y;
        return out;
    }
};

int main(int argc, char** argv) {
    std::vector<std::string> parameters;
    for(int i = 0; i < argc; i++) {
        parameters.push_back(std::string(argv[i]));
        std::cout << "Parameter " << i << ": " << parameters.at(i) << std::endl;
    }



    std::queue<std::string> koo;

    koo.push("Number one");
    koo.push("Number two");
    koo.push("Number three");

    while(!koo.empty()) {
        std::cout << koo.front() << std::endl;
        koo.pop();
    }

    std::deque<std::string> d;
    
    std::vector<int> list = {1, 6, 3, 8, 5, 3, 7, 4};

    std::vector<Vector2> vecList = {{2, 5}, {2, 7}, {65, 87}};

    Vector2 sum = std::accumulate(vecList.begin(), vecList.end(), Vector2{0, 0});

    std::random_device device;
    std::default_random_engine engine(device());
    std::shuffle(list.begin(), list.end(), engine);

    int a = 5;
    int b = 4;

    //std::swap(a, b);

    //std::min(a, b);
    //std::max(a, b);
    std::sort(list.begin(), list.end());

    std::fill(list.begin(), list.end(), 55);

    std::vector<int> anotherList(100);
    std::copy(list.begin(), list.end(), anotherList.begin() + 5);

    anotherList.erase(anotherList.begin() + 3, anotherList.begin() + 5);




    for(std::vector<int>::reverse_iterator it = list.rbegin(); it != list.rend(); it++) {
        std::cout << *it << std::endl;
    }

    //NotAVector<int> vec;
    print<std::string>("a");
    print<int>(10);
    print(10.0);

    std::array<int, 5> array;
    std::map<std::string, int> aMap;

    std::vector<int> vec(10);
    std::unique_ptr<int*> test;
    std::map<std::string, int> map;

    return 0;
}

