// Lecture 13, Example 1: templates, Dragana Laketic

#include "std_lib_facilities.h"
#include "Points.h"

int main() {
    // 1) Class template
    Point<int> pointI{1, 3}; // Here the compiler instantiates template class Point
                            // to 'int' data type instead of generic 'T' ...
    Point<double> pointD{10.5, 5.5}; // ... and here to 'double'.

    cout << "X coordinate int Point: " << pointI.getX() << endl;
    pointD.PrintMe();

    // 2) Class template with more than one typename parameter
    ChoppedPoint<int, double> pointC{4, 7.5};
    pointC.PrintMe();

    // 3) Function template
    cout << "Function template:" << endl;
    PrintValue<int>(5); // Providing explicitly data type to instantiate
                        // a function template with.
    PrintValue<string>("ABC"); // Explicit instantiation of the function template
                            // with data type 'string'.
    PrintValue(100); // An example of so-called template argument deduction when
                    // a compiler deduces which type the function template should
                    // be instantiated with based on the argument passed to a function.
                    // Here it was a simple case of a built-in data type int, but
                    // beware that for more complex types, for example user-defined
                    // classes, it is recommended providing an explicit data type
                    // for the function template instantiation like in the two examples
                    // above.

    // 4) Class template with one data type and one integer as parameters
    // Note: during lecture we mentioned such case for std::array but here
    // is an example of the use of a user-defined template with such parameters
    Collection<int, 10> coll; // Note: for exercise, extend class Collection with
                            // some functions and call those functions ofr coll object.

    return 0;
}
