#include <iostream>
#include <fstream>
#include <filesystem>

constexpr std::string config = "Game.txt"; 

class Point2D {
    int x;
    int y;
public:
    Point2D() : x{0}, y{0} {}
    Point2D(int a, int b) : x{a}, y{b} {}
    friend std::ostream& operator<<(std::ostream& outstream, const Point2D& pt);
};

std::ostream& operator<<(std::ostream& outstream, const Point2D& pt) {
    outstream << "(" << pt.x << ", " << pt.y << ")" << std::endl;
    return outstream;
}

int main() {
    std::filesystem::path fileName{"Game.txt"};
    std::ifstream inStream{fileName};
    int readScore;
    std::string readPlayerName{""};
    
    if (inStream.is_open()) {
        inStream >> readScore >> readPlayerName;
    }
    std::cout << "Read points: " << readScore << std::endl 
        << "Read Player Name: " << readPlayerName << std::endl;

    // We can also use function getline() from the standard library
    // to read the whole line from the file:
    //std::string line{""};
    //std::getline(inStream, line);
    //std::cout << "Read the line: " << line << std::endl;

    // example of calling operator << for a variable of a class type
    // (see the class and function definitions at the top of this file)
    Point2D startPos{5, 10};
    std::ofstream outStreamStart{"StartPosition.txt"};
    outStreamStart << startPos;

    return 0;
}