#pragma once
#include "Point.h"
#include <vector>

bool isBetween(int x, int lower, int upper);

class Racket {
    private:
        TDT4102::Point position;
        static constexpr int velocity = 8;
    public:
        static constexpr int length = 4;
        static constexpr int blockSize = 10;
        
        Racket() {}
        Racket(TDT4102::Point initPos) : position{initPos} {}
        TDT4102::Point getPosition() const { return position; };
        int getX() const { return position.x; }
        int getY() const { return position.y; }
        void moveUp();
        void moveDown();
};

class Ball {
    private:
        static constexpr int velocity = 8;
        static constexpr int blockSize = Racket::blockSize;
        TDT4102::Point position;
    
    public:
        double dirX = 0;
        double dirY = 0; 
        Ball() {}
        Ball(TDT4102::Point initPos, double x, double y) : position{initPos}, dirX{x}, dirY{y} {}
        TDT4102::Point getPosition() const { return position; }
        int getDir() const {
            return dirX >= 0 ? 1 : -1;
        }
        int getX() const { return position.x; }
        int getY() const { return position.y; }
        int nextX();
        int nextY();
        std::vector<double> calculateDirection(Racket racket);
        void setDirection(std::vector<double> nextDir);
        void move(); 

};