#pragma once
#include "AnimationWindow.h"
#include "widgets/Button.h"
#include "widgets/TextInput.h"
#include "Pong.h"

class PongWindow: public TDT4102::AnimationWindow {

public:
    PongWindow();
    void run();

private:

    //height and width of window in blocks.
    static constexpr int pongGridWidth  = 50;
    static constexpr int pongGridHeight = 30;

    static constexpr int blockSize = 10;
    static constexpr int racketLength = Racket::length*blockSize;

    static constexpr int windowHeight = pongGridHeight*blockSize;
    static constexpr int windowWidth = pongGridWidth*blockSize;

    bool isGamePaused = true;

    Racket playerLeft;
    Racket playerRight;
    Ball ball;

    unsigned int playerLeftScore = 0;
    unsigned int playerRightScore = 0;


    void handleInput();
    void drawBall();
    void drawPlayers();
    void handleCollision();

    TDT4102::Button startBtn;
    TDT4102::TextInput showPlayerLeftScore;
    TDT4102::TextInput showPlayerRightScore;

    void cb_start() { this->startGame(); }

    void startGame();

};