#include "AnimationWindow.h"
#include "Snake.h"
#include <random>
#include <chrono>


enum class Direction {RIGHT, UP, LEFT, DOWN};           

class GameWindow : public TDT4102::AnimationWindow {
    private:
        // ---------------- Game window parameters ----------------------------------- //
        /*
                TO-DO: Initialize the parameters for the game window and the grid 
        */

        // ---------------- Game window parameters ----------------------------------- //

        static constexpr int gridWidth = 20;         
        static constexpr int gridHeight = 20;
        static constexpr int blockSize = 30;

        Snake snake;                                        // Vector to represent the snake                                           
        TDT4102::Point food;                                         // Random point of food in grid
        std::default_random_engine foodRandomEngine;        // Machinery to generate random pos for food

        bool gameIsLost = false;                             // Game state
        

        // --------------- Member functions ------------------------------------------//
        void drawSnake();      
        bool isFoodOnSnake();
        bool hasSnakeCrashed(Direction dir);
        void sampleFood();                  // Assign position to food member-variable
        TDT4102::Point nextPoint(Direction dir);     // Find the coords of the next point in given direction of snake
        bool gameLost(Direction dir);       // Evaluate the state of game (collisions)

    public:
        /*
            TO-DO: Complete the declaration and definition of the Game-Window constructor
        */
       GameWindow(); 
       void run();
};